Index: /code/trunk/src/orxonox/core/ConfigValueContainer.cc
===================================================================
--- /code/trunk/src/orxonox/core/ConfigValueContainer.cc	(revision 870)
+++ /code/trunk/src/orxonox/core/ConfigValueContainer.cc	(revision 871)
@@ -416,8 +276,67 @@
         @return True if the string was successfully parsed
     */
-    bool ConfigValueContainer::parseSting(const std::string& input, unsigned char defvalue)
+    bool ConfigValueContainer::parseString(const std::string& input, unsigned char defvalue)
     {
         // I used value_uint_ instead of value_uchar_ to avoid number <-> char confusion in the config-file
-        return ConvertValue(&this->value_.value_uint_, input, (unsigned int)defvalue);
+        unsigned int temp;
+        bool success = ConvertValue(&temp, input, (unsigned int)defvalue);
+        this->value_.setValue((unsigned char)temp);
+        return success;
+    }
+
+    /**
+        @brief Parses a given std::string into a value of the type short and assigns it to the right variable. If the conversion failed, the default-value gets assigned.
+        @param input The string to convert
+        @param defvalue The default-value
+        @return True if the string was successfully parsed
+    */
+    bool ConfigValueContainer::parseString(const std::string& input, short defvalue)
+    {
+        short temp;
+        bool success = ConvertValue(&temp, input, defvalue);
+        this->value_.setValue(temp);
+        return success;
+    }
+
+    /**
+        @brief Parses a given std::string into a value of the type unsigned short and assigns it to the right variable. If the conversion failed, the default-value gets assigned.
+        @param input The string to convert
+        @param defvalue The default-value
+        @return True if the string was successfully parsed
+    */
+    bool ConfigValueContainer::parseString(const std::string& input, unsigned short defvalue)
+    {
+        unsigned short temp;
+        bool success = ConvertValue(&temp, input, defvalue);
+        this->value_.setValue(temp);
+        return success;
+    }
+
+    /**
+        @brief Parses a given std::string into a value of the type long and assigns it to the right variable. If the conversion failed, the default-value gets assigned.
+        @param input The string to convert
+        @param defvalue The default-value
+        @return True if the string was successfully parsed
+    */
+    bool ConfigValueContainer::parseString(const std::string& input, long defvalue)
+    {
+        long temp;
+        bool success = ConvertValue(&temp, input, defvalue);
+        this->value_.setValue(temp);
+        return success;
+    }
+
+    /**
+        @brief Parses a given std::string into a value of the type unsigned long and assigns it to the right variable. If the conversion failed, the default-value gets assigned.
+        @param input The string to convert
+        @param defvalue The default-value
+        @return True if the string was successfully parsed
+    */
+    bool ConfigValueContainer::parseString(const std::string& input, unsigned long defvalue)
+    {
+        unsigned long temp;
+        bool success = ConvertValue(&temp, input, defvalue);
+        this->value_.setValue(temp);
+        return success;
     }
 
@@ -428,7 +347,10 @@
         @return True if the string was successfully parsed
     */
-    bool ConfigValueContainer::parseSting(const std::string& input, float defvalue)
-    {
-        return ConvertValue(&this->value_.value_float_, input, defvalue);
+    bool ConfigValueContainer::parseString(const std::string& input, float defvalue)
+    {
+        float temp;
+        bool success = ConvertValue(&temp, input, defvalue);
+        this->value_.setValue(temp);
+        return success;
     }
 
@@ -439,7 +361,10 @@
         @return True if the string was successfully parsed
     */
-    bool ConfigValueContainer::parseSting(const std::string& input, double defvalue)
-    {
-        return ConvertValue(&this->value_.value_double_, input, defvalue);
+    bool ConfigValueContainer::parseString(const std::string& input, double defvalue)
+    {
+        double temp;
+        bool success = ConvertValue(&temp, input, defvalue);
+        this->value_.setValue(temp);
+        return success;
     }
 
@@ -450,7 +375,10 @@
         @return True if the string was successfully parsed
     */
-    bool ConfigValueContainer::parseSting(const std::string& input, long double defvalue)
-    {
-        return ConvertValue(&this->value_.value_long_double_, input, defvalue);
+    bool ConfigValueContainer::parseString(const std::string& input, long double defvalue)
+    {
+        long double temp;
+        bool success = ConvertValue(&temp, input, defvalue);
+        this->value_.setValue(temp);
+        return success;
     }
 
@@ -461,5 +389,5 @@
         @return True if the string was successfully parsed
     */
-    bool ConfigValueContainer::parseSting(const std::string& input, bool defvalue)
+    bool ConfigValueContainer::parseString(const std::string& input, bool defvalue)
     {
         // Try to parse the value-string - is it a word?
@@ -468,14 +396,17 @@
          || input.find("yes") < input.size()
          || input.find("Yes") < input.size())
-            this->value_.value_bool_ = true;
+            this->value_.setValue(true);
         else if (input.find("false") < input.size()
               || input.find("False") < input.size()
               || input.find("no") < input.size()
               || input.find("No") < input.size())
-            this->value_.value_bool_ = false;
+            this->value_.setValue(false);
         else
         {
             // Its not a known word - is it a number?
-            return ConvertValue(&this->value_.value_bool_, input, defvalue);
+            bool temp;
+            bool success = ConvertValue(&temp, input, defvalue);
+            this->value_.setValue(temp);
+            return success;
         }
 
@@ -489,5 +420,5 @@
         @return True if the string was successfully parsed
     */
-    bool ConfigValueContainer::parseSting(const std::string& input, const std::string& defvalue)
+    bool ConfigValueContainer::parseString(const std::string& input, const std::string& defvalue)
     {
         // Strip the quotes
@@ -499,10 +430,10 @@
         {
             // It was - get the string between the quotes
-            this->value_string_ = input.substr(pos1, pos2 - pos1);
+            this->value_.setValue(input.substr(pos1, pos2 - pos1));
             return true;
         }
 
         // It wasn't - use the default-value and restore the entry in the config-file.
-        this->value_string_ = defvalue;
+        this->value_.setValue(defvalue);
         return false;
     }
@@ -514,5 +445,5 @@
         @return True if the string was successfully parsed
     */
-    bool ConfigValueContainer::parseSting(const std::string& input, const char* defvalue)
+    bool ConfigValueContainer::parseString(const std::string& input, const char* defvalue)
     {
         // Strip the quotes
@@ -524,10 +455,10 @@
         {
             // It was - get the string between the quotes
-            this->value_string_ = input.substr(pos1, pos2 - pos1);
+            this->value_.setValue(input.substr(pos1, pos2 - pos1));
             return true;
         }
 
         // It wasn't - use the default-value and restore the entry in the config-file.
-        this->value_string_ = defvalue;
+        this->value_.setValue(defvalue);
         return false;
     }
@@ -539,5 +470,5 @@
         @return True if the string was successfully parsed
     */
-    bool ConfigValueContainer::parseSting(const std::string& input, const Vector2& defvalue)
+    bool ConfigValueContainer::parseString(const std::string& input, const Vector2& defvalue)
     {
         // Strip the value-string
@@ -549,12 +480,12 @@
         {
             std::vector<std::string> tokens = tokenize(input.substr(pos1, pos2 - pos1), ",");
-            if (!ConvertValue(&this->value_vector2_.x, tokens[0]))
-            {
-                this->value_vector2_ = defvalue;
-                return false;
-            }
-            if (!ConvertValue(&this->value_vector2_.y, tokens[1]))
-            {
-                this->value_vector2_ = defvalue;
+            if (!ConvertValue(&this->value_.getVector2().x, tokens[0]))
+            {
+                this->value_.setValue(defvalue);
+                return false;
+            }
+            if (!ConvertValue(&this->value_.getVector2().y, tokens[1]))
+            {
+                this->value_.setValue(defvalue);
                 return false;
             }
@@ -563,5 +494,5 @@
         }
 
-        this->value_vector2_ = defvalue;
+        this->value_.setValue(defvalue);
         return false;
     }
@@ -573,5 +504,5 @@
         @return True if the string was successfully parsed
     */
-    bool ConfigValueContainer::parseSting(const std::string& input, const Vector3& defvalue)
+    bool ConfigValueContainer::parseString(const std::string& input, const Vector3& defvalue)
     {
         // Strip the value-string
@@ -583,17 +514,17 @@
         {
             std::vector<std::string> tokens = tokenize(input.substr(pos1, pos2 - pos1), ",");
-            if (!ConvertValue(&this->value_vector3_.x, tokens[0]))
-            {
-                this->value_vector3_ = defvalue;
-                return false;
-            }
-            if (!ConvertValue(&this->value_vector3_.y, tokens[1]))
-            {
-                this->value_vector3_ = defvalue;
-                return false;
-            }
-            if (!ConvertValue(&this->value_vector3_.z, tokens[2]))
-            {
-                this->value_vector3_ = defvalue;
+            if (!ConvertValue(&this->value_.getVector3().x, tokens[0]))
+            {
+                this->value_.setValue(defvalue);
+                return false;
+            }
+            if (!ConvertValue(&this->value_.getVector3().y, tokens[1]))
+            {
+                this->value_.setValue(defvalue);
+                return false;
+            }
+            if (!ConvertValue(&this->value_.getVector3().z, tokens[2]))
+            {
+                this->value_.setValue(defvalue);
                 return false;
             }
@@ -602,5 +533,5 @@
         }
 
-        this->value_vector3_ = defvalue;
+        this->value_.setValue(defvalue);
         return false;
     }
@@ -612,5 +543,5 @@
         @return True if the string was successfully parsed
     */
-    bool ConfigValueContainer::parseSting(const std::string& input, const ColourValue& defvalue)
+    bool ConfigValueContainer::parseString(const std::string& input, const ColourValue& defvalue)
     {
         // Strip the value-string
@@ -622,22 +553,22 @@
         {
             std::vector<std::string> tokens = tokenize(input.substr(pos1, pos2 - pos1), ",");
-            if (!ConvertValue(&this->value_colourvalue_.r, tokens[0]))
-            {
-                this->value_colourvalue_ = defvalue;
-                return false;
-            }
-            if (!ConvertValue(&this->value_colourvalue_.g, tokens[1]))
-            {
-                this->value_colourvalue_ = defvalue;
-                return false;
-            }
-            if (!ConvertValue(&this->value_colourvalue_.b, tokens[2]))
-            {
-                this->value_colourvalue_ = defvalue;
-                return false;
-            }
-            if (!ConvertValue(&this->value_colourvalue_.a, tokens[3]))
-            {
-                this->value_colourvalue_ = defvalue;
+            if (!ConvertValue(&this->value_.getColourValue().r, tokens[0]))
+            {
+                this->value_.setValue(defvalue);
+                return false;
+            }
+            if (!ConvertValue(&this->value_.getColourValue().g, tokens[1]))
+            {
+                this->value_.setValue(defvalue);
+                return false;
+            }
+            if (!ConvertValue(&this->value_.getColourValue().b, tokens[2]))
+            {
+                this->value_.setValue(defvalue);
+                return false;
+            }
+            if (!ConvertValue(&this->value_.getColourValue().a, tokens[3]))
+            {
+                this->value_.setValue(defvalue);
                 return false;
             }
@@ -646,6 +577,72 @@
         }
 
-        this->value_colourvalue_ = defvalue;
+        this->value_.setValue(defvalue);
         return false;
+    }
+
+    /**
+        @brief Parses a given std::string into a value of the type Quaternion and assigns it to the right variable. If the conversion failed, the default-value gets assigned.
+        @param input The string to convert
+        @param defvalue The default-value
+        @return True if the string was successfully parsed
+    */
+    bool ConfigValueContainer::parseString(const std::string& input, const Quaternion& defvalue)
+    {
+        // Strip the value-string
+        unsigned int pos1 = input.find("(") + 1;
+        unsigned int pos2 = input.find(")", pos1);
+
+        // Try to convert the stripped value-string to Vector3
+        if (pos1 < input.length() && pos2 < input.length() && pos1 < pos2)
+        {
+            std::vector<std::string> tokens = tokenize(input.substr(pos1, pos2 - pos1), ",");
+            if (!ConvertValue(&this->value_.getQuaternion().w, tokens[0]))
+            {
+                this->value_.setValue(defvalue);
+                return false;
+            }
+            if (!ConvertValue(&this->value_.getQuaternion().x, tokens[1]))
+            {
+                this->value_.setValue(defvalue);
+                return false;
+            }
+            if (!ConvertValue(&this->value_.getQuaternion().y, tokens[2]))
+            {
+                this->value_.setValue(defvalue);
+                return false;
+            }
+            if (!ConvertValue(&this->value_.getQuaternion().z, tokens[3]))
+            {
+                this->value_.setValue(defvalue);
+                return false;
+            }
+
+            return true;
+        }
+
+        this->value_.setValue(defvalue);
+        return false;
+    }
+
+    /**
+        @brief Parses a given std::string into a value of the type long double and assigns it to the right variable. If the conversion failed, the default-value gets assigned.
+        @param input The string to convert
+        @param defvalue The default-value
+        @return True if the string was successfully parsed
+    */
+    bool ConfigValueContainer::parseString(const std::string& input, const Radian& defvalue)
+    {
+        return ConvertValue(&this->value_.getRadian(), input, defvalue);
+    }
+
+    /**
+        @brief Parses a given std::string into a value of the type long double and assigns it to the right variable. If the conversion failed, the default-value gets assigned.
+        @param input The string to convert
+        @param defvalue The default-value
+        @return True if the string was successfully parsed
+    */
+    bool ConfigValueContainer::parseString(const std::string& input, const Degree& defvalue)
+    {
+        return ConvertValue(&this->value_.getDegree(), input, defvalue);
     }
 
@@ -664,5 +661,5 @@
     void ConfigValueContainer::resetConfigValue()
     {
-        this->parseSting(this->defvalueString_);
+        this->parseString(this->defvalueString_, this->value_);
         this->resetConfigFileEntry();
     }
@@ -837,5 +834,6 @@
 
     /**
-        @returns a list, containing all entrys in the config-file.
+        @brief Rreturns a list, containing all entrys in the config-file.
+        @return The list
     */
     std::list<std::string>& ConfigValueContainer::getConfigFileLines()
@@ -879,4 +877,5 @@
         if (!file.is_open())
         {
+            COUT(1) << "An error occurred in ConfigValueContainer.cc:" << std::endl;
             COUT(1) << "Error: Couldn't open config-file " << filename << " to read the config values!" << std::endl;
             return;
@@ -925,4 +924,5 @@
         if (!file.is_open())
         {
+            COUT(1) << "An error occurred in ConfigValueContainer.cc:" << std::endl;
             COUT(1) << "Error: Couldn't open config-file " << filename << " to write the config values!" << std::endl;
             return;
@@ -948,7 +948,16 @@
         {
             this->description_ = std::string("ConfigValueDescription::" + this->classname_ + "::" + this->varname_);
-            Language::getLanguage().addEntry(this->description_, description);
+            AddLanguageEntry(this->description_, description);
             this->bAddedDescription_ = true;
         }
     }
+
+    /**
+        @brief Returns the description of the config-value.
+        @return The description
+    */
+    const std::string& ConfigValueContainer::getDescription() const
+    {
+        return GetLocalisation(this->description_);
+    }
 }
Index: /code/trunk/src/orxonox/core/ConfigValueContainer.h
===================================================================
--- /code/trunk/src/orxonox/core/ConfigValueContainer.h	(revision 870)
+++ /code/trunk/src/orxonox/core/ConfigValueContainer.h	(revision 871)
@@ -26,5 +26,5 @@
  */
 
-/*!
+/**
     @file ConfigValueContainer.h
     @brief Definition of the ConfigValueContainer class.
@@ -49,5 +49,5 @@
 
 #include "util/Math.h"
-#include "Language.h"
+#include "util/MultiTypeMath.h"
 
 namespace orxonox
@@ -72,65 +72,36 @@
     {
         public:
-            enum VariableType
-            {
-                VT_Int,
-                VT_uInt,
-                VT_Char,
-                VT_uChar,
-                VT_Float,
-                VT_Double,
-                VT_LongDouble,
-                VT_Bool,
-                VT_ConstChar,
-                VT_String,
-                VT_Vector2,
-                VT_Vector3,
-                VT_ColourValue
-            };
+            ConfigValueContainer(const std::string& classname, const std::string& varname, MultiTypeMath defvalue);
 
-            ConfigValueContainer(const std::string& classname, const std::string& varname, int defvalue);
-            ConfigValueContainer(const std::string& classname, const std::string& varname, unsigned int defvalue);
-            ConfigValueContainer(const std::string& classname, const std::string& varname, char defvalue);
-            ConfigValueContainer(const std::string& classname, const std::string& varname, unsigned char defvalue);
-            ConfigValueContainer(const std::string& classname, const std::string& varname, float defvalue);
-            ConfigValueContainer(const std::string& classname, const std::string& varname, double defvalue);
-            ConfigValueContainer(const std::string& classname, const std::string& varname, long double defvalue);
-            ConfigValueContainer(const std::string& classname, const std::string& varname, bool defvalue);
-            ConfigValueContainer(const std::string& classname, const std::string& varname, const std::string& defvalue);
-            ConfigValueContainer(const std::string& classname, const std::string& varname, const char* defvalue);
-            ConfigValueContainer(const std::string& classname, const std::string& varname, Vector2 defvalue);
-            ConfigValueContainer(const std::string& classname, const std::string& varname, Vector3 defvalue);
-            ConfigValueContainer(const std::string& classname, const std::string& varname, ColourValue defvalue);
-
-            /** @returns the value. @param value This is only needed to determine the right type. */
-            inline ConfigValueContainer& getValue(int& value)                           { value = this->value_.value_int_; return *this; }
-            /** @returns the value. @param value This is only needed to determine the right type. */
-            inline ConfigValueContainer& getValue(unsigned int& value)                  { value = this->value_.value_uint_; return *this; }
-            /** @returns the value. @param value This is only needed to determine the right type. */
-            inline ConfigValueContainer& getValue(char& value)                          { value = this->value_.value_char_; return *this; }
-            /** @returns the value. @param value This is only needed to determine the right type. */
-            inline ConfigValueContainer& getValue(unsigned char& value)                 { value = this->value_.value_uchar_; return *this; }
-            /** @returns the value. @param value This is only needed to determine the right type. */
-            inline ConfigValueContainer& getValue(float& value)                         { value = this->value_.value_float_; return *this; }
-            /** @returns the value. @param value This is only needed to determine the right type. */
-            inline ConfigValueContainer& getValue(double& value)                        { value = this->value_.value_double_; return *this; }
-            /** @returns the value. @param value This is only needed to determine the right type. */
-            inline ConfigValueContainer& getValue(long double& value)                   { value = this->value_.value_long_double_; return *this; }
-            /** @returns the value. @param value This is only needed to determine the right type. */
-            inline ConfigValueContainer& getValue(bool& value)                          { value = this->value_.value_bool_; return *this; }
-            /** @returns the value. @param value This is only needed to determine the right type. */
-            inline ConfigValueContainer& getValue(std::string& value)                   { value = this->value_string_; return *this; }
-            /** @returns the value. @param value This is only needed to determine the right type. */
-            inline ConfigValueContainer& getValue(const char* value)                    { value = this->value_string_.c_str(); return *this; }
-            /** @returns the value. @param value This is only needed to determine the right type. */
-            inline ConfigValueContainer& getValue(Vector2& value)                       { value = this->value_vector2_; return *this; }
-            /** @returns the value. @param value This is only needed to determine the right type. */
-            inline ConfigValueContainer& getValue(Vector3& value)                       { value = this->value_vector3_; return *this; }
-            /** @returns the value. @param value This is only needed to determine the right type. */
-            inline ConfigValueContainer& getValue(ColourValue& value)                   { value = this->value_colourvalue_; return *this; }
+            /** @brief Returns the configured value. @param value This is only needed to determine the right type. @return The value */
+/*            template <typename T>
+            inline ConfigValueContainer& getValue(T& value)                           { this->value_.getValue(value); return *this; }
+*/
+            inline ConfigValueContainer& getValue(int* value)            { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(unsigned int* value)   { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(char* value)           { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(unsigned char* value)  { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(short* value)          { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(unsigned short* value) { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(long* value)           { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(unsigned long* value)  { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(float* value)          { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(double* value)         { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(long double* value)    { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(bool* value)           { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(std::string* value)    { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(const char** value)    { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(Vector2* value)        { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(Vector3* value)        { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(ColourValue* value)    { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(Quaternion* value)     { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(Radian* value)         { this->value_.getValue(value); return *this; }
+            inline ConfigValueContainer& getValue(Degree* value)         { this->value_.getValue(value); return *this; }
 
             void description(const std::string& description);
+            const std::string& getDescription() const;
 
-            bool parseSting(const std::string& input);
+            bool parseString(const std::string& input, MultiTypeMath& defvalue);
+            bool valueToString(std::string* output, MultiTypeMath& input);
             void resetConfigFileEntry();
             void resetConfigValue();
@@ -141,17 +112,24 @@
 
         private:
-            bool parseSting(const std::string& input, int defvalue);
-            bool parseSting(const std::string& input, unsigned int defvalue);
-            bool parseSting(const std::string& input, char defvalue);
-            bool parseSting(const std::string& input, unsigned char defvalue);
-            bool parseSting(const std::string& input, float defvalue);
-            bool parseSting(const std::string& input, double defvalue);
-            bool parseSting(const std::string& input, long double defvalue);
-            bool parseSting(const std::string& input, bool defvalue);
-            bool parseSting(const std::string& input, const std::string& defvalue);
-            bool parseSting(const std::string& input, const char* defvalue);
-            bool parseSting(const std::string& input, const Vector2& defvalue);
-            bool parseSting(const std::string& input, const Vector3& defvalue);
-            bool parseSting(const std::string& input, const ColourValue& defvalue);
+            bool parseString(const std::string& input, int defvalue);
+            bool parseString(const std::string& input, unsigned int defvalue);
+            bool parseString(const std::string& input, char defvalue);
+            bool parseString(const std::string& input, unsigned char defvalue);
+            bool parseString(const std::string& input, short defvalue);
+            bool parseString(const std::string& input, unsigned short defvalue);
+            bool parseString(const std::string& input, long defvalue);
+            bool parseString(const std::string& input, unsigned long defvalue);
+            bool parseString(const std::string& input, float defvalue);
+            bool parseString(const std::string& input, double defvalue);
+            bool parseString(const std::string& input, long double defvalue);
+            bool parseString(const std::string& input, bool defvalue);
+            bool parseString(const std::string& input, const std::string& defvalue);
+            bool parseString(const std::string& input, const char* defvalue);
+            bool parseString(const std::string& input, const Vector2& defvalue);
+            bool parseString(const std::string& input, const Vector3& defvalue);
+            bool parseString(const std::string& input, const ColourValue& defvalue);
+            bool parseString(const std::string& input, const Quaternion& defvalue);
+            bool parseString(const std::string& input, const Radian& defvalue);
+            bool parseString(const std::string& input, const Degree& defvalue);
 
             static std::list<std::string>& getConfigFileLines();
@@ -167,26 +145,10 @@
             std::string         defvalueString_;                //!< The string of the default-variable
 
-            union MultiType
-            {
-                int                 value_int_;                 //!< The value, if the variable is of the type int
-                unsigned int        value_uint_;                //!< The value, if the variable is of the type unsigned int
-                char                value_char_;                //!< The value, if the variable is of the type char
-                unsigned char       value_uchar_;               //!< The value, if the variable is of the type unsigned char
-                float               value_float_;               //!< The value, if the variable is of the type float
-                double              value_double_;              //!< The value, if the variable is of the type double
-                long double         value_long_double_;         //!< The value, if the variable is of the type long double
-                bool                value_bool_;                //!< The value, if the variable is of the type bool
-            } value_;                                           //!< The value of the variable
-
-            std::string         value_string_;                  //!< The value, if the variable is of the type string
-            Vector2             value_vector2_;                 //!< The value, if the variable is of the type Vector2
-            Vector3             value_vector3_;                 //!< The value, if the variable is of the type Vector3
-            ColourValue         value_colourvalue_;             //!< The value, if the variable is of the type ColourValue
+            MultiTypeMath       value_;                         //!< The value
 
             std::list<std::string>::iterator configFileLine_;   //!< An iterator, pointing to the entry of the variable in the config-file
 
-            VariableType type_;                                 //!< The type of the variable
             bool bAddedDescription_;                            //!< True if a description was added
-            LanguageEntryName description_;                     //!< The description
+            LanguageEntryLabel description_;                    //!< The description
     };
 }
